﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Xml;
using System.Reflection;
using System.Threading;
using System.Xml.Serialization;
using System.Collections;
using System.Text;
using System.Windows.Controls;
using System.Windows.Threading;
using System.Windows;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using SilverlightSocketClient;
using LogicData;

namespace NetworkC
{
    public class NetworkClient
    {
        Socket socket = null;
        DnsEndPoint endPoint = null;

        private const int Receive = 1;
        private const int Send = 0;

        public void ClientStart()
        {
            //DnsEndPoint endPoint = new DnsEndPoint(Application.Current.Host.Source.DnsSafeHost, 4530);
            endPoint = new DnsEndPoint("dingpong.iptime.org", 4530);
            socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            SocketAsyncEventArgs args = new SocketAsyncEventArgs();
            args.UserToken = socket;
            args.RemoteEndPoint = endPoint;
            args.Completed += new EventHandler<SocketAsyncEventArgs>(OnSocketConnectCompleted);
            socket.ConnectAsync(args);
        }

       private void OnSocketConnectCompleted(object sender, SocketAsyncEventArgs e)
        {
            if (e.SocketError == SocketError.Success)
            {
                byte[] response = new byte[1024];
                e.SetBuffer(response, 0, response.Length);
                e.Completed -= new EventHandler<SocketAsyncEventArgs>(OnSocketConnectCompleted);
                e.Completed += new EventHandler<SocketAsyncEventArgs>(OnSocketReceive);
                Socket socket = (Socket)e.UserToken;
                socket.ReceiveAsync(e);
            }
            else
            {
                Page.Instance.Dispatcher.BeginInvoke(() => System.Windows.Browser.HtmlPage.Window.Alert(e.SocketError.ToString()));
            }
        }

        private void OnSend(object sender, SocketAsyncEventArgs e)
        {
        }

        internal String DataSend(string message)
        {
            if (socket.Connected)
            {
                Byte[] bytes = Encoding.UTF8.GetBytes(message);

                SocketAsyncEventArgs args = new SocketAsyncEventArgs();
                args.SetBuffer(bytes, 0, bytes.Length);
                args.UserToken = socket;
                args.RemoteEndPoint = endPoint;
                args.Completed += new EventHandler<SocketAsyncEventArgs>(OnSend);

                socket.SendAsync(args);

                return Encoding.UTF8.GetString(args.Buffer, args.Offset, args.BytesTransferred);
            }
            else
            {
                throw new SocketException((int)SocketError.NotConnected);
            }
        }

        private void OnSocketReceive(object sender, SocketAsyncEventArgs e)
        {
            try
            {
                // 받은 메세지를 로직에서 처리
                Page.Instance.logicClient.NetworkReceiveMsg(Encoding.UTF8.GetString(e.Buffer, e.Offset, e.BytesTransferred));
            }
            catch { }
            finally
            {
            }
            //Prepare to receive more data
            Socket socket = (Socket)e.UserToken;
            socket.ReceiveAsync(e);
        }
    }

}