﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using NetworkC;
using LogicC;
using SilverlightSocketClient.UIEvent;

namespace SilverlightSocketClient
{
    sealed partial class Page : UserControl
    {
       /// <summary>
        /// 싱글톤 선언 코드
        /// </summary>
        private static volatile Page instance;
        private static object syncRoot = new Object();

        private Page() 
        {
            InitializeComponent(); 
            this.Loaded += new RoutedEventHandler(Page_Loaded);
        }

        public static Page Instance
        {
            get
            {
                if (instance == null)
                {
                    lock (syncRoot)
                    {
                        if (instance == null)
                            instance = new Page();
                    }
                }

                return instance;
            }
        }
        // 싱글톤 끝

        public NetworkClient networkClient = new NetworkClient();
        public LogicClient logicClient = new LogicClient();
        public UIControl uiControl = new UIControl();
        
        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            networkClient.ClientStart();

            this.LayoutRoot.Children.Add(uiControl);
        }
    }
}
