using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Reflection;
using System.Xml;
using System.Xml.Serialization;
using System.IO;

using GameLogic;

// dingpong. DB  ȭ ſ ߿ϱ   ۾ ƴϸ  ̺귯   ɻ ظ å   .

namespace DataBase
{
    abstract class IDataManager
    {
        protected DataSet userDataSet;

        // db Ѵ.
        public abstract bool DBInitConnect(string serverName, string computerName, string userId, string password, string dbName);

        // table ÷ ȯѴ.
        public abstract DataTableCollection GetTableCollection(string tableName, ArrayList columns, string whereString, string orderString);
        // insert   ڵ带 ߰Ѵ.
        public abstract int InsertRecodeInTable(string tableName, ArrayList fieldList, ArrayList insertValue);
        // update   ڵ带 Ѵ.
        public abstract int UpdateRecodeInTable(string tableName, ArrayList fieldList, ArrayList updateValue, string whereString);
        // delete   ڵ带 Ѵ.
        public abstract int DeleteRecodeInTable(string tableName, string whereString);

        // Create Table   ̺ Ѵ.
        public abstract int CreateTable(string tableName, ArrayList columns, string primaryKeycolumn);
        // ALTER TABLE ADD   ̺ ÷ ߰Ѵ.
        public abstract int AddTableColumns(string tableName, ArrayList columns);
        // ALTER TABLE DROP COLUMN   ̺ ÷ Ѵ.
        public abstract int DropTableColumns(string tableName, ArrayList columns);
        // ALTER TABLE ALTER COLUMN   ̺ ÷ Ѵ.
        public abstract int UpdateTableColumns(string tableName, ArrayList columns);
        
        // Ư  Ų.
        public abstract int ExecuteQuery(string query);

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : protected bool IsExistTable(string tableName, bool clearData)
        // 		  :  ̺ dataset ϴ ˻ϴ Լ
        // 		  : ã ϴ ̺ ̸, ش ̺ ִٸ  ̺ clear    . clearData ̰ true   false 
        // 		  :   ϴ ̶̺ true  ƴ϶ false
        // 		  : clearData  Լ ȸ´   ϰ     ִ.
        ///////////////////////////////////////////////////////////////////////
        protected bool IsExistTable(string tableName, bool clearData)
        {
            // ̹ ش ̺ ͼ¿ ִٸ  ִ   ִ ٸ ó ش.
            if (userDataSet.Tables.Contains(tableName) == true)
            {
                if (clearData == false)
                    return true;
                else
                    userDataSet.Tables[tableName].Clear();
            }
            return false;
        }

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : protected void Init()
        // 		  :   ʱȭ ϴ  ʱȭ Ȱ
        // 		  : DB Connect Ŀ  Լ ҷѴ.
        ///////////////////////////////////////////////////////////////////////
        protected void Init()
        {
            userDataSet = new DataSet();
        }

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public void PrintTableData(DataTable dt)
        // 		  : ̺  ȭ鿡 
        // 		  : ϰ ϴ ̺ 
        // 		  : 
        // 		  : Console 󿡼  .
        ///////////////////////////////////////////////////////////////////////
        public void PrintTableData(DataTable dt)
        {
            Console.WriteLine("_Start Print Table. Table Name Is '{0}' ", dt.TableName.ToString());
            foreach (DataRow dr in dt.Rows)
            {
                //   ִ ʹ Ϻκ  ֱ  ÷   ش.
                for (int i = 0; i < dt.Columns.Count; ++i)
                {
                    Console.WriteLine("{0} : {1}", dt.Columns[i].ToString(), dr[i].ToString());
                }
            }
            Console.WriteLine("_Print End");
        }
    }

    // SQL ؼ DB ó   ִ DataBaseManager Դϴ.
    class SqlDataManager : IDataManager
    {
        private SqlConnection   connection = null;
        private SqlDataAdapter  userData;

        // Ҹ  DB Ȥ ִ °ų ҴǾ ִ   ش.
        ~SqlDataManager()
        {
            if (connection != null)
            {
                connection.Close();
            }
        }

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void DBInitConnect(string serverName, string computerName, string userId, string password, string dbName)
        // 		  : SQL Database     ֵ ִ ԼԴϴ.
        // 		  : ̸, ͺ̽ ǻ ̸, ,йȣ,Ϸ db̸
        // 		  :   ߴ
        // 		  : Ȯ ׸ ڸ     ϴ.
        ///////////////////////////////////////////////////////////////////////
        public override bool DBInitConnect(string serverName, string computerName, string userId, string password, string dbName)
        {
            string connectionString = "Server="
                                    + serverName
                                    + ";database="
                                    + computerName
                                    + ";User ID="
                                    + userId
                                    + ";Password="
                                    + password
                                    + ";Initial Catalog="
                                    + dbName;

            try
            {
                connection = new SqlConnection(connectionString);
                connection.Open();

                Init();

                Console.WriteLine("DataBase Connect Success");
                return true;
            }
            catch (Exception e)
            {
                if (connection != null)
                {
                    connection.Close();
                }
                
                Console.WriteLine("DataBase Connect faild");
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "DBInitConnect");
                return false;
            }
        }

        /////////////////////////////////////////////////////////////////////////
        // ڵ  Լ /////////////////////////////////////////////////

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override DataTableCollection GetTableCollection(string tableName, ArrayList columns, string whereString, string orderString)
        // 		  : Select  ڽ ϴ ̺ ÷ ´
        // 		  : ϴ ̺ ̸,   ÷ (ȳ * !), where  ǹ, order  
        // 		  : select   ̺  ִ ÷ 
        // 		  : tableName ܿ ٸ  Է ʾƵ մϴ..
        ///////////////////////////////////////////////////////////////////////
        public override DataTableCollection GetTableCollection(string tableName, ArrayList columns, string whereString, string orderString)
        {
            try
            {
                // شϴ ̺  ִٸ clear ༭ ͼ¿ Ͱ ġ ʵ óش.
                IsExistTable(tableName, true);

                string query = "select ";

                if (columns.Count != 0)
                {
                    for (int i = 0; i < columns.Count; ++i)
                    {
                        //  ϼϱ  ó
                        query += columns[i].ToString();
                        if (i != columns.Count - 1)
                            query += ", ";
                        else
                            query += " ";
                    }
                }
                else
                {
                    query += "* ";
                }

                query += "from " + tableName;

                // ǹ ó
                if (whereString != null)
                {
                    query += " where ";
                    query += whereString;
                }
                //   ó
                if (orderString != null)
                {
                    query += " order by ";
                    query += orderString;
                }

                userData = new SqlDataAdapter(query, connection);

                userData.Fill(userDataSet, tableName);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "GetTableCollection");
            }
            return userDataSet.Tables;
        }

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override int InsertRecodeInTable(string tableName, ArrayList fieldList, ArrayList insertValue)
        // 		  : insert  ̿Ͽ Ư ̺ ڵ带 ߰Ų.
        // 		  : ϴ ̺ ̸, ߰ ϴ ʵ(÷)Ʈ ߰ϰ ϴ  Ʈ ִ´.
        // 		  : command.ExecuteNonQuery()  
        // 		  : insertValue fieldList ĪϿ ͸ Է½Ų. fieldList Count 0̶ ü ͸ ־Ѵ. ࿡ ڵ Į ִٸ  Į Է ʰ پѴ´.
        ///////////////////////////////////////////////////////////////////////
        public override int InsertRecodeInTable(string tableName, ArrayList fieldList, ArrayList insertValue)
        {
            try
            {
                // insert into table_name(field1, field2) values('000', '222');

                // insert   ̺ ͸ ߰ش.
                string query = "insert into " + tableName;

                // ʵ Ͱ Է Ǿٸ  ش.
                if (fieldList.Count != 0)
                {
                    query += "(";
                    for (int i = 0; i < fieldList.Count; ++i)
                    {
                        query += fieldList[i];
                        if (i != insertValue.Count - 1)
                            query += ", ";
                    }
                    query += ")";
                }
                //   ԷϿ  ϼѴ.
                query += " values(";

                for (int i = 0; i < insertValue.Count; ++i)
                {
                    query += "'";
                    query += insertValue[i];
                    query += "'";
                    if (i != insertValue.Count - 1)
                        query += ", ";
                }

                query += ")";

                //  Ѵ
                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "InsertRecodeInTable");
                return 0;
            }
            // DataSet  ͸ ߰ϴ ƾ. ⼭ insert      ¿ ִ  ó ʴ´.
            /*
                         //  ͼ¿ ش ̺   ִ ˻.  ٸ ̺ ü оδ.
                        if (userDataSet.Tables.Contains(tableName) == false)
                            GetTableAllCollection(tableName);

                        DataTable insertTable = userDataSet.Tables[tableName];
                        DataRow newRow = insertTable.NewRow();

                        int indexCount = 0;
                        for (int i = 0; i < insertTable.Columns.Count; ++i)
                        {
                            if(insertTable.Columns[i].AutoIncrement == false)
                            {
                                newRow[insertTable.Columns[i].ToString()] = insertValue[indexCount];
                                ++indexCount;
                            }
                        }
                        insertTable.Rows.Add(newRow);

                        userData.Update(userDataSet, tableName);
            */
        }
        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void UpdateRecodeInTable(string tableName, ArrayList fieldList, ArrayList updateValue, string whereString)
        // 		  : update  Ͽ Ư ̺ ڵ  Ѵ.
        // 		  : ϴ ̺ ̸, ʵ(÷) ϴ , ׸  ڵ    ϴ ǹ
        // 		  : command.ExecuteNonQuery()  
        // 		  :  Լ ڴ   ־մϴ. whereString  ȳ־  ش ̺   ٲϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int UpdateRecodeInTable(string tableName, ArrayList fieldList, ArrayList updateValue, string whereString)
        {
            try
            {
                if (updateValue.Count == 0 || fieldList.Count == 0)
                    return 0;

                string query = "Update " + tableName + " Set ";

                for (int i = 0; i < updateValue.Count; ++i)
                {
                    query += fieldList[i];
                    query += "='";
                    query += updateValue[i];
                    query += "' ";
                    if (i != updateValue.Count - 1)
                        query += ", ";
                }
                if (whereString != "")
                {
                    query += "where ";
                    query += whereString;
                }

                //  Ѵ
                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "UpdateRecodeInTable");
                return 0;
            }
        }
        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void DeleteRecodeInTable(string tableName, string whereString)
        // 		  : delete  ̿Ͽ Ư ̺ ڵ带 Ѵ.
        // 		  : ϴ ̺ ̸, ׸  ڵ带  ΰ  ǹ
        // 		  : command.ExecuteNonQuery()  
        // 		  : ڸ   ־ մϴ. ǹ   ̺ ִ ڵ尡   ˴ϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int DeleteRecodeInTable(string tableName, string whereString)
        {
            try
            {
                string query = "Delete from ";

                query += tableName;

                if (whereString != "")
                {
                    query += " where ";
                    query += whereString;
                }

                //  Ѵ
                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "DeleteRecodeInTable");
                return 0;
            }
        }

        /////////////////////////////////////////////////////////////////////////
        // ̺  Լ /////////////////////////////////////////////////

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void CreateTable(string tableName, ArrayList columns, string primaryKeycolumn)
        // 		  : create table  ̿Ͽ ̺ Ѵ.
        // 		  : ϴ ̺ ̸, ߰ϰ ϴ ÷ ̸ , primaryKeyŰ ϰ ϴ ÷
        // 		  : command.ExecuteNonQuery()  
        // 		  : primaryKeycolumn  ʾƵ ˴ϴ. ÷ ʹ "÷̸  NULL" ̷  ־ֽø ˴ϴ. NULL    մϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int CreateTable(string tableName, ArrayList columns, string primaryKeycolumn)
        {
            try
            {
                string query = "CREATE TABLE ";
                query += tableName;

                query += "(";
                for (int i = 0; i < columns.Count; ++i)
                {
                    query += columns[i];

                    if (i != columns.Count - 1)
                        query += ", ";
                }
                if (primaryKeycolumn != "")
                {
                    query += ", ";
                    query += "CONSTRAINT PK_";
                    query += tableName;
                    query += " PRIMARY KEY (";
                    query += primaryKeycolumn;
                    query += ")";
                }
                query += ")";

                //  Ѵ
                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "CreateTable");
                return 0;
            }
        }

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void AddTableColumns(string tableName, ArrayList columns)
        // 		  : ALTER TABLE  ̿Ͽ ̺ ÷ ߰Ѵ.
        // 		  : ϴ ̺ ̸, ߰ϰ ϴ ÷ ̸ 
        // 		  : command.ExecuteNonQuery()  
        // 		  : ÷ ʹ "÷̸  NULL" ̷  ־ֽø ˴ϴ. NULL    մϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int AddTableColumns(string tableName, ArrayList columns)
        {
            try
            {
                string query = "ALTER TABLE ";
                query += tableName;

                query += " ADD ";

                for (int i = 0; i < columns.Count; ++i)
                {
                    query += columns[i];
                    query += " NULL "; // ߰ ϴ ÷  ϳ    NULL  Ѵ.
                    if (i != columns.Count - 1)
                        query += ", ";
                }

                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "AddTableColumns");
                return 0;
            }
        }

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void DropTableColumns(string tableName, ArrayList columns)
        // 		  : ALTER TABLE  ̿Ͽ ̺ ÷ Ѵ.
        // 		  : ϴ ̺ ̸, ߰ϰ ϴ ÷ ̸ 
        // 		  : command.ExecuteNonQuery()  
        // 		  : primaryKeycolumn  ʾƵ ˴ϴ. ÷ "÷̸ "    Էϼžմϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int DropTableColumns(string tableName, ArrayList columns)
        {
            try
            {
                string query = "ALTER TABLE ";
                query += tableName;

                query += " DROP COLUMN ";

                for (int i = 0; i < columns.Count; ++i)
                {
                    query += columns[i];
                    if (i != columns.Count - 1)
                        query += ", ";
                }

                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "DropTableColumns");
                return 0;
            }
        }
        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void UpdateTableColumns(string tableName, ArrayList columns)
        // 		  : ALTER TABLE  ̿Ͽ ̺ ÷ Ѵ.
        // 		  : ϴ ̺ ̸, ߰ϰ ϴ ÷ ̸ 
        // 		  : command.ExecuteNonQuery()  
        // 		  : ÷ "÷̸ "    Էϼžմϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int UpdateTableColumns(string tableName, ArrayList columns)
        {
            try
            {
                string query = "ALTER TABLE ";
                query += tableName;

                query += " ALTER COLUMN ";

                for (int i = 0; i < columns.Count; ++i)
                {
                    query += columns[i];
                    query += " NULL "; // ߰ ϴ ÷  ϳ    NULL  Ѵ.
                    if (i != columns.Count - 1)
                        query += ", ";
                }

                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "UpdateTableColumns");
                return 0;
            }
        }

        /////////////////////////////////////////////////////////////////////////////////
        // ڷ  string   Ų.

        ///////////////////////////////////////////////////////////////////////
        // Լ ̸  : public override void ExecuteQuery(string query)
        // 		  : Ư  
        // 		  :  ϴ 
        // 		  : command.ExecuteNonQuery()  
        // 		  :   Էϴ ̱    Ȯ Էؾմϴ.
        ///////////////////////////////////////////////////////////////////////
        public override int ExecuteQuery(string query)
        {
            try
            {
                SqlCommand command = new SqlCommand(query, connection);
                return command.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                LogicManager.Instance.Util.LogError(e, "ExecuteQuery");
                return 0;
            }
        }
    }

    //class OracleDataManager : IDataManager
    //{
    //}

    // ms access database  ٷ  ִ.
    //class MSAccessDataManager : IDataManager
    //{
    //    void IDataManager.InIt()
    //    {
    //        try
    //        {
    //            string connectionString = "provider=Microsoft.JET.OLEDB.4.0;"
    //                                    + "data source = "
    //                                    + Application.StartupPath
    //                                    + @"\test.mdb";

    //            string commandString = "select * from phone";

    //            OleDbDataAdapter DBAdapter
    //                = new OleDbDataAdapter(commandString, connectionString);

    //            OleDbCommandBuilder myCommandBuilder
    //                = new OleDbCommandBuilder(DBAdapter);

    //            DataSet DS = new DataSet();
    //        }
    //        catch (DataException DE)
    //        {
    //        }
    //        catch (Exception DE)
    //        {
    //        }
    //    }
    //}
}
